<template>
  <div>
        <section>
            <h3>resultado {{filteredItems.length}} de {{doctores.length}} doctores</h3>
        </section>

        <section class="aling-results">
           
            <ul class="card-doctor animationinitial">
                <li  
                    v-for="(doctor, index) in filteredItems" 
                    :key="doctor.id" 
                    :style="{ 'background-image': `url(` + doctor.avatar + `)`}" 
                    class="background-image-doctor" > 

                <div class="gradient-image animation-card">
                    <!-- gradiente -->
                </div>
                    <div  class="container-data">
                        <div class="data-top">
                            <div class="data-name-rating spacerborder id">
                                <span class="size-stars" > 
                                    Rating {{printStars(doctor.rating)}}
                                    <span v-if=" !doctor.rating ">sin valoración</span>
                                </span>
                                <!-- <strong>
                                    Rating{{ doctor.rating }}

                                </strong> -->
                                <hr class="card-hr">
                                <h2 class="name ">
                                    {{ doctor.name }}
                                </h2>
                                <p class="slogan">
                                    {{ doctor.surname }}
                                </p>
                            </div>
                            <div  v-if="isPatientOrDoctor === 'normal'"  class="data-videochat " >
                                <a :href="doctor.url_video" v-if="doctor.url_video" target="_blank" alt="VideoChat Activo" title="VideoChat Activo" class="cursor-pointer videochat">
                                 <i class="iconneed-video-chat "></i>
                                </a>
                            </div>
                        </div>

                        <div  class="data-bottom" >
                        <!-- class="summary-data"> -->
                            <div>
                                <ul class="card-summary-data">
                                    <li>
                                        <p>Especilidad:</p>
                                        {{ doctor.specialty_group }}
                                    </li>

                                    <li>
                                        <p>Disponibilidad:</p>
                                        {{availableDoc(doctor.available)}}
                                        {{ doctor.available }}
                                    </li>

                                    <li>
                                        <p>Experiencia:</p>
                                        {{$moment().diff(doctor.years_experience, 'years')}} años
                                    </li>
                                </ul>

                                <!-- <div v-if="isPatientOrDoctor === 'doctor'" class="spacerborder align-buttons">
                                    <p class="slogan"><br></p>
                                </div> -->
                                
                                    <!-- Edad: {{$moment().diff(doctor.age, 'years')}} años  |   -->
                                <div class="spacerborder align-buttons animationbuttoncard">
                                    <button v-if="isPatientOrDoctor === 'normal'"  @click="enviarIndice(index)" :disabled="!EnableDisable" class="button-second">
                                        Enviar Consulta
                                    </button>
                                    <button @click="enviarIndiceFicha(index)" class="button-second ">
                                       Ver Ficha
                                    </button>
                
                                </div>
                            </div>

                            
                        </div>
                    </div>
                </li>
                <!-- muestra dos doctores mas a los resultados -->
            </ul>
            <button  @click="chargeAll += 4" v-if="doctores.length > chargeAll" 
                class=" button-prime load-more">Cargar más</button>

        </section>
      
  </div>
</template>

<script>
import moment from 'moment'
import { getIsAdmin } from '../../../backend/utils/utils'
import { getIsPack } from '../../../backend/utils/utils'

var before = moment('2017.02.12 09:00','YYYY.MM.DD HH:mm');
var now = moment();


export default {
    name:'ListDoctors',
    data(){
        return{
            // comprueba que tipo del role tiene el usuario
            isPatientOrDoctor: getIsAdmin(),
            user_getispack: getIsPack(),

            // número de resultados iniciales de la busqueda
            chargeAll: 8,

             EnableDisable: true

        }
    },
    // Función para cargar mas resultados
    computed: {
    filteredItems() {
        return this.doctores.slice(0, this.chargeAll)
        },

    },
 
    props:{
        // recibimos lista doctores
        doctores: Array,
        dataDoctor:'',
        dataDoctorFile:'',


    },
    methods: {
        //mostramos u ocultamos botón dependiendo de pack que tengas contratado
        availableDoc(data){

            if(this.user_getispack == 'Baja'){
                if ( data == 'Media'){
                    return this.EnableDisable = false 
                }
                if ( data == 'Alta'){
                    return this.EnableDisable = false 
                }
                if ( data == 'Baja'){
                    return this.EnableDisable = true 
                }
            } 
            if(this.user_getispack == 'Media'){
                if ( data == 'Media'){
                    return this.EnableDisable = true 
                }
                if ( data == 'Alta'){
                    return this.EnableDisable = false 
                }
            } 
            
             

        },

        showIfUser(availableDoctor){
            if(this.user_getispack == availableDoctor){
                
                return false

            }else{
                return false
            }
            
        },
        
         enviarIndice(index){
             // recogemos el mail del la ficha selecionada
             // y lo enviamos a traves del router.params hacia SendInquiry

            let dataDoctor = this.doctores[index].email
            // El name Send está definico en la ruta correspondiente de index
            this.$router.push({name: 'Send', params: {emaildoc: dataDoctor}})

        },
        enviarIndiceFicha(index){
             // recogemos el id del la ficha selecionada
             // y lo enviamos a traves del router.params hacia DoctorFile

            let dataDoctorFile = this.doctores[index].id
            // El name: doctorfile está definico en la ruta correspondiente de index
            this.$router.push({name: 'doctorfile', params: {id: dataDoctorFile}})

        },

         //Para redondear la valoración
        printStars(valor){
            this.round()
            let stars = '';
            if (valor < 1){
                stars='sin valoración'
            }
            else if (valor > 0 && valor <= 1){
                stars = '★ ☆ ☆ ☆ ☆'
                return stars;
            } else if ( valor > 1 && valor <=2){
                stars = '★ ★ ☆ ☆ ☆'
                return stars;
            } else if ( valor > 2 && valor <=3){
                stars = '★ ★ ★ ☆ ☆'
                return stars;
            } else if ( valor > 3 && valor <=4){
                stars = '★ ★ ★ ★ ☆'
                return stars;
            } else if (valor > 4 && valor <= 5 || valor > 5){
                stars = `★ ★ ★ ★ ★`
                return stars;
            }
        },
        round(valor){
            return Number.parseFloat(valor).toFixed(0)
        }
    },
    
}
//  <a :href="this.$router.push({name: 'doctorfile', params: {id: 1}})">prueba</a>

</script>



<style scoped>

h3{
    margin-top: var(--spacer-6);
    text-align: left;
}

/*  base cards con */
.card-doctor {
    display: flex;
    flex-wrap: wrap;
}

.card-doctor > li {
    width: 250px;
    height: 350px;
    background-color: var( --color-general-black);
    list-style: none;
    text-align: left;
    border-radius: 4px;
    padding:var(--spacer-15) 1rem;
    margin:0.4rem;
    border: 0px solid var(--color-general-whitesmoke);
    box-shadow: 0px 3px 8px -2px rgba(0,0,0,0.1);
    position: relative;
    
    transition: all 1s ease;
    }

.card-doctor > li:hover {
    z-index:100;
    box-shadow: 0px 5px 9px -3px rgba(0,0,0,1);
    margin:0;
    width: 260px;
    height: 360px;

}
            
.animationbuttoncard{
    opacity: 0;
}

/* animación varios detalles al hacer hover */
.card-doctor > li .card-summary-data {   
        transform: translateY(20px);
}

.card-doctor > li:hover .card-summary-data{
    transform: translateY(0px);
    opacity: 1;
    animation: 1s ease-in-out swingDataBottons; 
} 

.card-doctor > li .animationbuttoncard {
    transform: translateY(10px);
    opacity: 0;
}
.card-doctor > li:hover .animationbuttoncard {
    transform: translateY(0px);
    opacity: 1;
    animation: 1s ease-in-out swingDataBottonsOpacity; 
} 


.aling-results{
    display: flex;
    flex-direction: column;
    justify-items: center;
} 

.size-stars{
    font-size: .7rem;
    color: var(--color-general-salmon);
}


.background-image-doctor {
  -webkit-background-size: cover;
  -moz-background-size: cover;
  -o-background-size: cover;
  background-size: cover;
  background-repeat: no-repeat;
  background-blend-mode: luminosity;

}

/* dividir el card en dos partes top y bottom */

.data-top {
    display: flex;
    height: 50%;
}

.data-bottom {
    height: 50%;
    display: flex;
    align-items: flex-end;
  
}

.gradient-image {
    position: absolute; left: 0px; top: 0px;
    width: 100%;
    height: 100%;
    background: linear-gradient(rgba(0,0,0,.01),rgba(0 ,0,0,.8));
    border-radius: 4px;
}

.container-data{
    position: absolute; 
    left: 0px;
    top: 0px;
    width: 100%;
    height: 100%;
    color: var(--color-general-white);
}

.card-hr {
  margin: 0.5rem 0;
  border: 1px solid var(--color-general-salmon);
  width: 5rem;
}

.name {
    color: var(--color-general-salmon);
}

.card-summary-data {
    display: flex;
    width: 50px;
    font-size: 12px;
    font-weight: 100;
    padding:1rem;
    

}
.card-summary-data > li {
    border-right: 1px solid  rgba(255,255,255,.4);;
    padding-right: 10px;
    padding-left: 10px;
}
.card-summary-data > li:first-child {
    padding-left: 0px;
}
.card-summary-data > li:last-child {
    padding-right: 0px;
    border-right:none;

}
.card-summary-data > li > p {
    font-weight:400;
    padding-bottom: 5px;
}

.spacerborder{ 
    padding-right: 10px;
    padding-left: 10px;
}

.id{
    padding-top: 10px;
}

/* botón cargar más */
.load-more {
    width: 90%;
}

.videochat {
    font-size:var(--font-size-2);
    color: var(--color-general-white);
    background-color: var(--color-general-green); 
    padding: 5px;

}

.color-prime-doctor {
  color:var(--color-general-green);
}

.bordercolor-prime-doctor {
  border-color:var(--color-general-green);
}

.align-buttons {
    align-items: center;
    text-align: center;
    display: block;
    padding-bottom: 5px;
}
.data-videochat {
    width: 25%;
    text-align: center;
    padding: 20px 10px;
}
.data-name-rating {
    width: 75%;
    opacity:1;
    animation: 2s ease-in-out swingTitleRating; 

}


/* ------------------------------------------
-------------- KEYFRAMES ANIMATION ----------
---------------------------------------------  */

/* titulo de las cards */
@keyframes swingTitleRating {
  from {
    transform: translateX(-10px);
    opacity: 0;

  }
  to {
    transform: translateX(0px);
    opacity: 1;
  }
}

/* movimiento botones inferiores card */
@keyframes swingDataBottonsOpacity {
  from {
    transform: translateY(10px);
    opacity: 0;

  }
  to {
    transform: translateY(0px);
    opacity: 1;
  }
}
/* movimiento txt infeior cards al hacer hover */
@keyframes swingDataBottons {
  from {
    transform: translateY(20px);

  }
  to {
    transform: translateY(0px);
  }
}

</style>